Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90	(revision 6772)
@@ -24,4 +24,6 @@
    USE crs
    USE crsdom
+   USE domvvl
+   USE domvvl_crs
    USE crslbclnk
    USE iom
@@ -32,5 +34,5 @@
    USE zdftke_crs
 
-!   USE ieee_arithmetic
+   USE ieee_arithmetic
 
    IMPLICIT NONE
@@ -77,5 +79,6 @@
       REAL(wp), POINTER, DIMENSION(:,:,:,:) :: avte_crs
       REAL(wp)       :: z2dcrsu, z2dcrsv
-      REAL(wp)       :: zmin,zmax,icnt1,icnt2
+      REAL(wp)       :: z1_2dt
+      REAL(wp)       :: icnt1,icnt2
       INTEGER :: i,j,ijis,ijie,ijjs,ijje
       REAL(wp)       :: zw,zwp1,zum1,zu,zvm1,zv,zsnm,zsm,z
@@ -85,4 +88,5 @@
       INTEGER ::  iji,ijj
       INTEGER :: jl,jm,jn
+      REAL(wp)       :: zmin,zmax,zsuma0,zsuma1,zsuma2,zsuma3,zsumb0,zsumb1,zsumb2,zsumb3,zsumb4
       !!
       !!----------------------------------------------------------------------
@@ -101,9 +105,4 @@
       CALL wrk_alloc( jpi_crs, jpj_crs, z2d_crs     )
 
-      ! Depth work arrrays
-      zfse3t(:,:,:) = fse3t(:,:,:)
-      zfse3u(:,:,:) = fse3u(:,:,:)
-      zfse3v(:,:,:) = fse3v(:,:,:)
-      zfse3w(:,:,:) = fse3w(:,:,:)
 
       IF( kt == nit000  ) THEN
@@ -124,4 +123,5 @@
          emp_b_crs(:,:    ) = 0._wp    ! emp
          rnf_crs  (:,:    ) = 0._wp    ! runoff
+         rnf_b_crs(:,:    ) = 0._wp    ! runoff
          fr_i_crs (:,:    ) = 0._wp    ! ice cover
       ENDIF
@@ -129,11 +129,78 @@
       CALL iom_swap( "nemo_crs" )    ! swap on the coarse grid
 
-      ! 2. Coarsen fields at each time step
-      ! --------------------------------------------------------
+      !---------------------------------------------------------------------------------------------------
+      !variables domaine au temps before : swap 
+      !---------------------------------------------------------------------------------------------------
+#if defined key_vvl
+      e3t_b_crs(:,:,:) = e3t_n_crs(:,:,:)
+      e3u_b_crs(:,:,:) = e3u_n_crs(:,:,:)
+      e3v_b_crs(:,:,:) = e3v_n_crs(:,:,:)
+      e3w_b_crs(:,:,:) = e3w_n_crs(:,:,:)
+      e3t_n_crs(:,:,:) = e3t_a_crs(:,:,:)
+      e3u_n_crs(:,:,:) = e3u_a_crs(:,:,:)
+      e3v_n_crs(:,:,:) = e3v_a_crs(:,:,:)
+      e3w_n_crs(:,:,:) = e3w_a_crs(:,:,:)
+#endif
+
+      IF( kt /= nit000 )THEN
+         tsb_crs(:,:,:,jp_tem) = tsn_crs(:,:,:,jp_tem) 
+         tsb_crs(:,:,:,jp_sal) = tsn_crs(:,:,:,jp_sal) 
+         ub_crs(:,:,:)         = un_crs(:,:,:) 
+         vb_crs(:,:,:)         = vn_crs(:,:,:) 
+         sshb_crs(:,:)         = sshb_crs(:,:)
+         emp_b_crs(:,:)        = emp_crs(:,:)
+         rnf_b_crs(:,:)        = rnf_crs(:,:)
+         rb2_crs(:,:,:)        = rn2_crs(:,:,:)
+      ENDIF
+
+      !---------------------------------------------------------------------------------------------------
+      !variables domaine au temps now : 
+      !---------------------------------------------------------------------------------------------------
+#if defined key_vvl
+      zfse3t(:,:,:) = e3t_n(:,:,:)
+      zfse3u(:,:,:) = e3u_n(:,:,:)
+      zfse3v(:,:,:) = e3v_n(:,:,:)
+      zfse3w(:,:,:) = e3w_n(:,:,:)
+
+      CALL crs_dom_sfc( umask, 'U', e2e3u_crs, e2e3u_msk, p_e2=e2u, p_e3=zfse3u )
+      CALL crs_dom_sfc( vmask, 'V', e1e3v_crs, e1e3v_msk, p_e1=e1v, p_e3=zfse3v )
+      !                                                                                 
+      CALL crs_dom_e3( e1t, e2t, zfse3t, p_sfc_3d_crs=e1e2w_crs, cd_type='T', p_mask=tmask, p_e3_crs=zs_crs, p_e3_max_crs=e3t_max_0_crs)
+      CALL crs_dom_e3( e1t, e2t, zfse3w, p_sfc_3d_crs=e1e2w_crs, cd_type='W', p_mask=tmask, p_e3_crs=zs_crs, p_e3_max_crs=e3w_max_0_crs)
+      CALL crs_dom_e3( e1u, e2u, zfse3u, p_sfc_2d_crs=e2u_crs  , cd_type='U', p_mask=umask, p_e3_crs=zs_crs, p_e3_max_crs=e3u_max_0_crs)
+      CALL crs_dom_e3( e1v, e2v, zfse3v, p_sfc_2d_crs=e1v_crs  , cd_type='V', p_mask=vmask, p_e3_crs=zs_crs, p_e3_max_crs=e3v_max_0_crs)
+
+      CALL crs_dom_ope( gdepw_n, 'MAX', 'T', tmask, gdept_n_crs, p_e3=zfse3t, psgn=1.0 )
+      CALL crs_dom_ope( gdepw_n, 'MAX', 'W', tmask, gdepw_n_crs, p_e3=zfse3w, psgn=1.0 )
+
+      CALL crs_dom_facvol( tmask, 'T', e1t, e2t, zfse3t, ocean_volume_crs_t, facvol_t )
+      CALL iom_put("ocean_volume_crs_t",ocean_volume_crs_t)
+      !
+      bt_crs(:,:,:) = ocean_volume_crs_t(:,:,:) * facvol_t(:,:,:)*tmask_crs(:,:,:)
+      !
+      r1_bt_crs(:,:,:) = 0._wp
+      WHERE( bt_crs /= 0._wp ) r1_bt_crs(:,:,:) = 1._wp / bt_crs(:,:,:)
+
+      CALL crs_dom_facvol( tmask, 'W', e1t, e2t, zfse3w, ocean_volume_crs_w, facvol_w )
+
+#endif
+
+#if defined key_vvl
+      zfse3t(:,:,:) = e3t_n(:,:,:)
+      zfse3u(:,:,:) = e3u_n(:,:,:)
+      zfse3v(:,:,:) = e3v_n(:,:,:)
+      zfse3w(:,:,:) = e3w_n(:,:,:)
+      CALL iom_put("e3t",e3t_n_crs)
+      CALL iom_put("e3u",e3u_n_crs)
+      CALL iom_put("e3v",e3v_n_crs)
+      CALL iom_put("e3w",e3w_n_crs)
+#else
+      zfse3t(:,:,:) = e3t_0(:,:,:)
+      zfse3u(:,:,:) = e3u_0(:,:,:)
+      zfse3v(:,:,:) = e3v_0(:,:,:)
+      zfse3w(:,:,:) = e3w_0(:,:,:)
+#endif
 
       !  Temperature
-      zt(:,:,:) = tsb(:,:,:,jp_tem)  ;      zt_crs(:,:,:) = 0._wp
-      CALL crs_dom_ope( zt, 'VOL', 'T', tmask, zt_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
-      tsb_crs(:,:,:,jp_tem) = zt_crs(:,:,:)
       zt(:,:,:) = tsn(:,:,:,jp_tem)  ;      zt_crs(:,:,:) = 0._wp
       CALL crs_dom_ope( zt, 'VOL', 'T', tmask, zt_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
@@ -143,14 +210,5 @@
       CALL iom_put( "sst" , tsn_crs(:,:,1,jp_tem) )    ! sst
 
-      !n2 before
-      zt(:,:,:) = rn2b(:,:,:)  ;      zt_crs(:,:,:) = 0._wp
-      CALL crs_dom_ope( zt, 'VOL', 'W', tmask, zt_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
-      rb2_crs(:,:,:) = zt_crs(:,:,:)
-      CALL iom_put("rb2_crs",rb2_crs)
-
       !  Salinity
-      zs(:,:,:) = tsb(:,:,:,jp_sal)  ;      zs_crs(:,:,:) = 0._wp
-      CALL crs_dom_ope( zs, 'VOL', 'T', tmask, zs_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
-      tsb_crs(:,:,:,jp_sal) = zs_crs(:,:,:)
       zs(:,:,:) = tsn(:,:,:,jp_sal)  ;      zs_crs(:,:,:) = 0._wp
       CALL crs_dom_ope( zs, 'VOL', 'T', tmask, zs_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
@@ -161,84 +219,25 @@
 
       !  U-velocity
-      CALL crs_dom_ope( ub, 'SUM', 'U', umask, ub_crs, p_e12=e2u, p_e3=zfse3u, p_surf_crs=e2e3u_msk, psgn=-1.0 )
       CALL crs_dom_ope( un, 'SUM', 'U', umask, un_crs, p_e12=e2u, p_e3=zfse3u, p_surf_crs=e2e3u_msk, psgn=-1.0 )
-      !cbr
-      ub_crs(:,:,:) = ub_crs(:,:,:)*umask_crs(:,:,:)
       un_crs(:,:,:) = un_crs(:,:,:)*umask_crs(:,:,:)
-      !
-      zt(:,:,:) = 0._wp     ;    zs(:,:,:) = 0._wp  ;   zt_crs(:,:,:) = 0._wp   ;    zs_crs(:,:,:) = 0._wp
+      CALL iom_put( "uoce"  , un_crs )   ! i-current 
+
+      !  V-velocity
+      CALL crs_dom_ope( vn, 'SUM', 'V', vmask, vn_crs, p_e12=e1v, p_e3=zfse3v, p_surf_crs=e1e3v_msk, psgn=-1.0 )
+      vn_crs(:,:,:) = vn_crs(:,:,:)*vmask_crs(:,:,:)
+      CALL iom_put( "voce"  , vn_crs )   ! i-current 
+     
+      !  Horizontal divergence ( following OPA_SRC/DYN/divcur.F90 ) 
+      hdivn_crs(:,:,:)=0._wp
+
       DO jk = 1, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1   
-               zt(ji,jj,jk)  = un(ji,jj,jk) * 0.5 * ( tsn(ji,jj,jk,jp_tem) + tsn(ji+1,jj,jk,jp_tem) ) 
-               zs(ji,jj,jk)  = un(ji,jj,jk) * 0.5 * ( tsn(ji,jj,jk,jp_sal) + tsn(ji+1,jj,jk,jp_sal) ) 
-            END DO
-         END DO
-      END DO
-      CALL crs_dom_ope( zt, 'SUM', 'U', umask, zt_crs, p_e12=e2u, p_e3=zfse3u, p_surf_crs=e2e3u_msk, psgn=-1.0 )
-      CALL crs_dom_ope( zs, 'SUM', 'U', umask, zs_crs, p_e12=e2u, p_e3=zfse3u, p_surf_crs=e2e3u_msk, psgn=-1.0 )
-
-      CALL iom_put( "uoce"  , un_crs )   ! i-current 
-      CALL iom_put( "uocet" , zt_crs )   ! uT
-      CALL iom_put( "uoces" , zs_crs )   ! uS
-
-      !  V-velocity
-      CALL crs_dom_ope( vb, 'SUM', 'V', vmask, vb_crs, p_e12=e1v, p_e3=zfse3v, p_surf_crs=e1e3v_msk, psgn=-1.0 )
-      CALL crs_dom_ope( vn, 'SUM', 'V', vmask, vn_crs, p_e12=e1v, p_e3=zfse3v, p_surf_crs=e1e3v_msk, psgn=-1.0 )
-      vb_crs(:,:,:) = vb_crs(:,:,:)*vmask_crs(:,:,:)
-      vn_crs(:,:,:) = vn_crs(:,:,:)*vmask_crs(:,:,:)
-      !                                                                                 
-      zt(:,:,:) = 0._wp     ;    zs(:,:,:) = 0._wp  ;   zt_crs(:,:,:) = 0._wp   ;    zs_crs(:,:,:) = 0._wp
-      DO jk = 1, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1   
-               zt(ji,jj,jk)  = vn(ji,jj,jk) * 0.5 * ( tsn(ji,jj,jk,jp_tem) + tsn(ji,jj+1,jk,jp_tem) ) 
-               zs(ji,jj,jk)  = vn(ji,jj,jk) * 0.5 * ( tsn(ji,jj,jk,jp_sal) + tsn(ji,jj+1,jk,jp_sal) ) 
-            END DO
-         END DO
-      END DO
-      CALL crs_dom_ope( zt, 'SUM', 'V', vmask, zt_crs, p_e12=e1v, p_e3=zfse3v, p_surf_crs=e1e3v_msk, psgn=-1.0 )
-      CALL crs_dom_ope( zs, 'SUM', 'V', vmask, zs_crs, p_e12=e1v, p_e3=zfse3v, p_surf_crs=e1e3v_msk, psgn=-1.0 )
- 
-      CALL iom_put( "voce"  , vn_crs )   ! i-current 
-      CALL iom_put( "vocet" , zt_crs )   ! vT
-      CALL iom_put( "voces" , zs_crs )   ! vS
-
-     
-      !  Kinetic energy
-      CALL crs_dom_ope( rke, 'VOL', 'T', tmask, rke_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
-      CALL iom_put( "eken", rke_crs )
-
-      !  Horizontal divergence ( following OPA_SRC/DYN/divcur.F90 ) 
-      DO jk = 1, jpkm1
-         DO ji = 2, jpi_crsm1
-            DO jj = 2, jpj_crsm1
-               IF( tmask_crs(ji,jj,jk ) > 0 ) THEN
-                  !z2dcrsu =  ( un_crs(ji  ,jj  ,jk) * crs_surfu_wgt(ji  ,jj  ,jk) ) &
-                  !   &     - ( un_crs(ji-1,jj  ,jk) * crs_surfu_wgt(ji-1,jj  ,jk) )
-                  !z2dcrsv =  ( vn_crs(ji  ,jj  ,jk) * crs_surfv_wgt(ji  ,jj  ,jk) ) &
-                  !   &     - ( vn_crs(ji  ,jj-1,jk) * crs_surfv_wgt(ji  ,jj-1,jk) )
-                  !
-                  !IF( crs_volt_wgt(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / crs_volt_wgt(ji,jj,jk)
-                  z2dcrsu =  ( un_crs(ji  ,jj  ,jk) * e2e3u_msk(ji  ,jj  ,jk) ) &
-                     &     - ( un_crs(ji-1,jj  ,jk) * e2e3u_msk(ji-1,jj  ,jk) )
-                  z2dcrsv =  ( vn_crs(ji  ,jj  ,jk) * e1e3v_msk(ji  ,jj  ,jk) ) &
-                     &     - ( vn_crs(ji  ,jj-1,jk) * e1e3v_msk(ji  ,jj-1,jk) )
-                  !
-                  !cbr
-                  !bug1: il manquait le facvol_t(ji,jj,jk) ds la division ; ca creait des grosses erreurs de Wcrs ( vu en recalculant la divergence 3D )
-                  !bug2: mm test que bug1: on n'obtient tjs pas zero
-                  !on a la div calculée via ocean_volume_crs_t puis w via  e3t_crs ; or ,e1t_crs(ji,jj)*e2t_crs(ji,jj)*e3t_crs(ji,jj,jk) NE ocean_volume_crs_t*crs_volt_wgt(ji,jj,jk)
-                  !exp (117,211,74) : e1*e2*e3=235206030060.005 / ocean_volume_crs_t * facvol = 235205585307.810
-                  !                   e1*e2*e3-cean_volume_crs_t * facvol/(cean_volume_crs_t * facvol) ~1.e-6)  
-                  IF( ocean_volume_crs_t(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv )
-
-                  z2dcrsu =  ( ub_crs(ji  ,jj  ,jk) * e2e3u_msk(ji  ,jj  ,jk) ) &
-                     &     - ( ub_crs(ji-1,jj  ,jk) * e2e3u_msk(ji-1,jj  ,jk) )
-                  z2dcrsv =  ( vb_crs(ji  ,jj  ,jk) * e1e3v_msk(ji  ,jj  ,jk) ) &
-                     &     - ( vb_crs(ji  ,jj-1,jk) * e1e3v_msk(ji  ,jj-1,jk) )
-                  !
-                  IF( ocean_volume_crs_t(ji,jj,jk) .NE. 0._wp ) hdivb_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / (facvol_t(ji,jj,jk)*ocean_volume_crs_t(ji,jj,jk) )
-               ENDIF
+         DO jj = 2,jpj_crs
+            DO ji = 2,jpi_crs
+               z2dcrsu =  ( un_crs(ji  ,jj  ,jk) * e2e3u_msk(ji  ,jj  ,jk) ) &
+                 &      - ( un_crs(ji-1,jj  ,jk) * e2e3u_msk(ji-1,jj  ,jk) )
+               z2dcrsv =  ( vn_crs(ji  ,jj  ,jk) * e1e3v_msk(ji  ,jj  ,jk) ) &
+                 &      - ( vn_crs(ji  ,jj-1,jk) * e1e3v_msk(ji  ,jj-1,jk) )
+
+               hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv )
             ENDDO
          ENDDO
@@ -248,18 +247,4 @@
       CALL iom_put( "hdiv", hdivn_crs )  
 
-
-      !  W-velocity
-      IF( ln_crs_wn ) THEN
-         CALL crs_dom_ope( wn, 'SUM', 'W', tmask, wn_crs, p_e12=e1e2t, p_surf_crs=e1e2w_msk, psgn=1.0 )
-      ELSE
-        wn_crs(:,:,jpk) = 0._wp
-        DO jk = jpkm1, 1, -1
-           wn_crs(:,:,jk) = e1e2w_msk(:,:,jk+1)*wn_crs(:,:,jk+1) - hdivn_crs(:,:,jk)
-           WHERE( e1e2w_msk(:,:,jk) .NE. 0._wp )  wn_crs(:,:,jk) =  wn_crs(:,:,jk) /e1e2w_msk(:,:,jk) 
-        ENDDO
-      ENDIF
-
-      CALL iom_put( "woce", wn_crs  )   ! vertical velocity
-      !  free memory
 
       !  avt, avs
@@ -276,4 +261,5 @@
             CALL crs_dom_ope( avt, 'MED', 'W', tmask, avt_crs, p_e12=e1e2t, p_e3=zfse3w, psgn=1.0 )
          CASE ( 5 )
+#if defined key_zdftke
             CALL crs_dom_ope( en , 'VOL', 'W', tmask, en_crs, p_e12=e1e2t, p_e3=zfse3w, psgn=1.0 )
             CALL crs_dom_ope( taum , 'SUM', 'T', tmask, taum_crs , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
@@ -282,4 +268,5 @@
             CALL tke_avn_crs
             CALL zdf_evd_crs(kt)
+#endif
          CASE ( 6 )
 
@@ -295,10 +282,6 @@
             CALL crs_dom_ope( zt, 'VOL', 'W', tmask, zt_crs, p_e12=e1e2t, p_e3=ztmp, psgn=1.0 )
             CALL crs_dom_ope( zs, 'VOL', 'W', tmask, zs_crs, p_e12=e1e2t, p_e3=ztmp, psgn=1.0 )
-            zmin=MINVAL(zt_crs);zmax=MAXVAL(zt_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte1_crs",zmin,zmax 
-            zmin=MINVAL(zs_crs);zmax=MAXVAL(zs_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte1_crs",zmin,zmax 
             zt_crs=tmask_crs*zt_crs
-            zmin=MINVAL(zt_crs);zmax=MAXVAL(zt_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte1_crs",zmin,zmax 
             WHERE( zs_crs .NE. 0._wp ) avte_crs(:,:,:,1) = zt_crs / zs_crs
-            zmin=MINVAL(avte_crs(:,:,:,1));zmax=MAXVAL(avte_crs(:,:,:,1));CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte1_crs",zmin,zmax 
 
             zt(:,:,:) = 0._wp
@@ -310,10 +293,6 @@
             CALL crs_dom_ope( zt, 'VOL', 'W', tmask, zt_crs, p_e12=e1e2t, p_e3=ztmp, psgn=1.0 )
             CALL crs_dom_ope( zs, 'VOL', 'W', tmask, zs_crs, p_e12=e1e2t, p_e3=ztmp, psgn=1.0 )
-            zmin=MINVAL(zt_crs);zmax=MAXVAL(zt_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte2_crs",zmin,zmax 
-            zmin=MINVAL(zs_crs);zmax=MAXVAL(zs_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte2_crs",zmin,zmax 
             zt_crs=tmask_crs*zt_crs
-            zmin=MINVAL(zt_crs);zmax=MAXVAL(zt_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte1_crs",zmin,zmax
             WHERE( zs_crs .NE. 0._wp ) avte_crs(:,:,:,2) = zt_crs / zs_crs
-            zmin=MINVAL(avte_crs(:,:,:,2));zmax=MAXVAL(avte_crs(:,:,:,2));CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte2_crs",zmin,zmax
 
             zt(:,:,:) = 0._wp
@@ -326,10 +305,6 @@
             CALL crs_dom_ope( zt, 'VOL', 'W', tmask, zt_crs, p_e12=e1e2t, p_e3=ztmp, psgn=1.0 )
             CALL crs_dom_ope( zs, 'VOL', 'W', tmask, zs_crs, p_e12=e1e2t, p_e3=ztmp, psgn=1.0 )
-            zmin=MINVAL(zt_crs);zmax=MAXVAL(zt_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte3_crs",zmin,zmax 
-            zmin=MINVAL(zs_crs);zmax=MAXVAL(zs_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte3_crs",zmin,zmax 
             zt_crs=tmask_crs*zt_crs
-            zmin=MINVAL(zt_crs);zmax=MAXVAL(zt_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte3_crs",zmin,zmax
             WHERE( zs_crs .NE. 0._wp ) avte_crs(:,:,:,3) = zt_crs / zs_crs
-            zmin=MINVAL(avte_crs(:,:,:,3));zmax=MAXVAL(avte_crs(:,:,:,3));CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte3_crs",zmin,zmax
 
             zt(:,:,:) = 0._wp
@@ -342,10 +317,6 @@
             CALL crs_dom_ope( zt, 'VOL', 'W', tmask, zt_crs, p_e12=e1e2t, p_e3=ztmp, psgn=1.0 )
             CALL crs_dom_ope( zs, 'VOL', 'W', tmask, zs_crs, p_e12=e1e2t, p_e3=ztmp, psgn=1.0 )
-            zmin=MINVAL(zt_crs);zmax=MAXVAL(zt_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte4_crs",zmin,zmax 
-            zmin=MINVAL(zs_crs);zmax=MAXVAL(zs_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte4_crs",zmin,zmax 
             zt_crs=tmask_crs*zt_crs
-            zmin=MINVAL(zt_crs);zmax=MAXVAL(zt_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte4_crs",zmin,zmax
             WHERE( zs_crs .NE. 0._wp ) avte_crs(:,:,:,4) = zt_crs / zs_crs
-            zmin=MINVAL(avte_crs(:,:,:,4));zmax=MAXVAL(avte_crs(:,:,:,4));CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avte4_crs",zmin,zmax
 
             CALL iom_put( "avte_crs1", avte_crs(:,:,:,1) )   !  Kz
@@ -353,15 +324,10 @@
             CALL iom_put( "avte_crs3", avte_crs(:,:,:,3) )   !  Kz
             CALL iom_put( "avte_crs4", avte_crs(:,:,:,4) )   !  Kz
-!--------------------- 
+
             CALL crs_dom_ope( avt, 'MED', 'W', tmask, zs_crs, p_e12=e1e2t, p_e3=zfse3w, p_mask_crs=tmask_crs, psgn=1.0 )
-!?            zmin=MINVAL(zs_crs*tmask_crs);zmax=MAXVAL(zs_crs*tmask_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"logvol zs_crs*tmask ",zmin,zmax ; call flush(numout)
             CALL iom_put( "zs_crs", zs_crs )   !  Kzlogvol
-!--------------------- ok
 
             CALL crs_dom_ope( avt, 'VOL', 'W', tmask, zmax_crs, p_e12=e1e2t, p_e3=zfse3w,  psgn=1.0 )
-            WRITE(narea+200,*)"zmax_crs ",SHAPE(zmax_crs) ; call flush(narea+200)
             CALL iom_put( "zmax_crs", zmax_crs )   !  Kzlogvol
-            zmin=MINVAL(zmax_crs*tmask_crs);zmax=MAXVAL(zmax_crs*tmask_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"vol zmax_crs*tmask ",zmin,zmax ; call flush(numout)
-!-------------------------nok
             avt_crs=zs_crs
 
@@ -379,8 +345,6 @@
 
  
-!--------------
                zwgt(1:4)=0._wp
                DO jm=1,4 ; IF( avte_crs(ji,jj,jk,jm)  .GE. 0._wp .AND.  avte_crs(ji,jj,jk,jm)  .LE. zmax_crs(ji,jj,jk)  ) zwgt(jm) = 1._wp ; ENDDO
-!--------------
                IF( SUM(zwgt(1:4)) .NE. 0._wp ) THEN  
                   zmean = SUM( zwgt(1:4)*avte_crs(ji,jj,jk,1:4)) / SUM(zwgt(1:4) )
@@ -390,5 +354,4 @@
                  zerr=1.e10
                ENDIF
-!--------------
 
                zerr_crs(ji,jj,jk)=zerr
@@ -400,16 +363,8 @@
                IF( tmask_crs(ji,jj,jk) == 1 .AND.  zerr .LE. zerr0 .AND. zmean .GT. 0._wp ) icnt2=icnt2+1
 
-               !IF( ieee_is_nan(  zt_crs(ji,jj,jk))   )WRITE(narea+200,*)"NANMEANEFF ",ji,jj,jk,tmask_crs(ji,jj,jk)  ; call flush(narea+200)
-               !IF( ieee_is_nan(  zs_crs(ji,jj,jk))   )WRITE(narea+200,*)"NANLOG ",ji,jj,jk,tmask_crs(ji,jj,jk)  ; call flush(narea+200)
-               !IF( ieee_is_nan( avt_crs(ji,jj,jk))   )WRITE(narea+200,*)"NANAVT ",ji,jj,jk,tmask_crs(ji,jj,jk)  ; call flush(narea+200)
-            ENDDO
-            ENDDO
-            ENDDO
-            zmin=MINVAL(avt_crs);zmax=MAXVAL(avt_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avt_crs ",zmin,zmax  ; call flush(numout)
-            zmin=MINVAL(avt_crs*tmask_crs);zmax=MAXVAL(avt_crs*tmask_crs);CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"avt_crs*tmask ",zmin,zmax  ; call flush(numout)
-
-            CALL mpp_sum(icnt1)
-            CALL mpp_sum(icnt2)
-            IF(lwp)WRITE(numout,*)"TOTO",kt,icnt1,icnt2
+            ENDDO
+            ENDDO
+            ENDDO
+
             CALL iom_put( "zt_crs", zt_crs )   !  Kz
             CALL iom_put( "zerr_crs", zerr_crs )   !  Kz
@@ -419,12 +374,5 @@
       CALL iom_put( "avt", avt_crs )   !  Kz
      
-      !deja dasn step CALL zdf_mxl_crs(kt)
-
- 
-      !  sbc fields  
-
-      CALL crs_dom_ope( sshb , 'VOL', 'T', tmask, sshb_crs , p_e12=e1e2t, p_e3=zfse3t         , psgn=1.0 )  
       CALL crs_dom_ope( sshn , 'VOL', 'T', tmask, sshn_crs , p_e12=e1e2t, p_e3=zfse3t         , psgn=1.0 )  
-      CALL crs_dom_ope( ssha , 'VOL', 'T', tmask, ssha_crs , p_e12=e1e2t, p_e3=zfse3t         , psgn=1.0 )  
       CALL crs_dom_ope( utau , 'SUM', 'U', umask, utau_crs , p_e12=e2u  , p_surf_crs=e2u_crs  , psgn=1.0 )
       CALL crs_dom_ope( vtau , 'SUM', 'V', vmask, vtau_crs , p_e12=e1v  , p_surf_crs=e1v_crs  , psgn=1.0 )
@@ -432,6 +380,12 @@
       CALL crs_dom_ope( rnf  , 'MAX', 'T', tmask, rnf_crs                                     , psgn=1.0 )
       CALL crs_dom_ope( qsr  , 'SUM', 'T', tmask, qsr_crs  , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
-      CALL crs_dom_ope( emp_b, 'SUM', 'T', tmask, emp_b_crs, p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
+#if defined key_vvl
+      CALL crs_dom_ope( gdepw_n, 'MAX', 'W', tmask, gdepw_n_crs, p_e3=zfse3w, psgn=1.0 )
+#else
+      CALL crs_dom_ope( gdepw_0, 'MAX', 'W', tmask, gdepw_0_crs, p_e3=zfse3w, psgn=1.0 )
+#endif
+
       CALL crs_dom_ope( emp  , 'SUM', 'T', tmask, emp_crs  , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
+
       CALL crs_dom_ope( fmmflx,'SUM', 'T', tmask, fmmflx_crs, p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
       CALL crs_dom_ope( sfx  , 'SUM', 'T', tmask, sfx_crs  , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
@@ -453,4 +407,69 @@
       CALL iom_put( "ice_cover", fr_i_crs )   ! ice cover output 
 
+#if defined key_vvl
+     !---------------------------------------------------------------------------------------------------
+     !variables au temps after
+     !---------------------------------------------------------------------------------------------------
+
+     zfse3t(:,:,:) = 1._wp
+     zt(:,:,:) = tmask(:,:,:)
+     ssha(:,:) = ssha(:,:) * tmask(:,:,1)
+     CALL crs_dom_ope( ssha , 'VOL', 'T', zt, ssha_crs , p_e12=e1e2t,  p_e3=zfse3t , psgn=1.0 )
+     CALL crs_lbc_lnk( ssha_crs, 'T', 1.0 ) !!!!!!!!!!!!!!!!!!! pas utile !!!!!!!!!!!!!!!!!!!!!!!!!
+
+     zfse3t(:,:,:) = e3t_a(:,:,:)
+     zfse3u(:,:,:) = e3u_a(:,:,:)
+     zfse3v(:,:,:) = e3v_a(:,:,:)
+     CALL dom_vvl_interpol( zfse3t(:,:,:), zfse3w(:,:,:), 'W'   )
+
+     CALL crs_dom_sfc( umask, 'U', zt_crs, zs_crs, p_e2=e2u, p_e3=zfse3u ) ! zt_crs=e2e3u_crs,zs_crs=e2e3u_msk
+     CALL crs_dom_sfc( vmask, 'V', zt_crs, zs_crs, p_e1=e2v, p_e3=zfse3v ) ! zt_crs=e1e3v_crs,zs_crs=e1e3v_msk
+     CALL crs_dom_e3( e1t, e2t, zfse3t, p_sfc_3d_crs=e1e2w_crs, cd_type='T', p_mask=tmask, p_e3_crs=e3t_a_crs, p_e3_max_crs=zs_crs)
+     CALL crs_dom_e3( e1t, e2t, zfse3w, p_sfc_3d_crs=e1e2w_crs, cd_type='W', p_mask=tmask, p_e3_crs=e3w_a_crs, p_e3_max_crs=zs_crs)
+     CALL crs_dom_e3( e1u, e2u, zfse3u, p_sfc_2d_crs=e2u_crs  , cd_type='U', p_mask=umask, p_e3_crs=e3u_a_crs, p_e3_max_crs=zs_crs)
+     CALL crs_dom_e3( e1v, e2v, zfse3v, p_sfc_2d_crs=e1v_crs  , cd_type='V', p_mask=vmask, p_e3_crs=e3v_a_crs, p_e3_max_crs=zs_crs)
+
+
+     DO jk = 1, jpk
+        DO ji = 1, jpi_crs
+           DO jj = 1, jpj_crs
+              IF( e3t_a_crs(ji,jj,jk) == 0._wp ) e3t_a_crs(ji,jj,jk) = e3t_1d(jk)
+              IF( e3w_a_crs(ji,jj,jk) == 0._wp ) e3w_a_crs(ji,jj,jk) = e3w_1d(jk)
+              IF( e3u_a_crs(ji,jj,jk) == 0._wp ) e3u_a_crs(ji,jj,jk) = e3t_1d(jk)
+              IF( e3v_a_crs(ji,jj,jk) == 0._wp ) e3v_a_crs(ji,jj,jk) = e3t_1d(jk)
+           ENDDO
+       ENDDO
+     ENDDO
+
+     !zt_crs=ocean_volume_crs_t ; zs_crs=facvol_t after time !!!
+     CALL crs_dom_facvol( tmask, 'T', e1t, e2t, zfse3t, zt_crs, zs_crs )
+
+#endif
+
+#if defined key_vvl
+      z1_2dt = 1._wp / ( 2. * rdt )                         ! set time step size (Euler/Leapfrog)
+      IF( neuler == 0 .AND. kt == nit000 )   z1_2dt = 1._wp / rdt
+      wn_crs(:,:,jpk) = 0._wp
+      DO jk = jpkm1, 1, -1
+         wn_crs(:,:,jk) = wn_crs(:,:,jk+1)*e1e2w_msk(:,:,jk+1) - (  hdivn_crs(:,:,jk)                                   &
+               &                          + z1_2dt * e1e2w_crs(:,:,jk) * ( e3t_a_crs(:,:,jk) - e3t_b_crs(:,:,jk) ) ) * tmask_crs(:,:,jk)
+         WHERE( e1e2w_msk(:,:,jk) .NE. 0._wp )  wn_crs(:,:,jk) =  wn_crs(:,:,jk) /e1e2w_msk(:,:,jk)
+      ENDDO
+#else
+      IF( ln_crs_wn ) THEN
+         CALL crs_dom_ope( wn, 'SUM', 'W', tmask, wn_crs, p_e12=e1e2t, p_surf_crs=e1e2w_msk, psgn=1.0 )
+      ELSE
+         wn_crs(:,:,jpk) = 0._wp
+         DO jk = jpkm1, 1, -1
+            wn_crs(:,:,jk) = e1e2w_msk(:,:,jk+1)*wn_crs(:,:,jk+1) - hdivn_crs(:,:,jk)
+            WHERE( e1e2w_msk(:,:,jk) .NE. 0._wp )  wn_crs(:,:,jk) =  wn_crs(:,:,jk) /e1e2w_msk(:,:,jk)
+         ENDDO
+       ENDIF
+
+#endif
+      CALL crs_lbc_lnk( wn_crs, 'W', 1.0 )   !!!!!!!pas utile, nan ??????????????????????
+      wn_crs(:,:,:) = wn_crs(:,:,:) * tmask_crs(:,:,:)
+      CALL iom_put( "woce", wn_crs  )   ! vertical velocity
+
       !  free memory
       CALL wrk_dealloc( jpi, jpj, jpk, zfse3t, zfse3w )
